#include "motion.h"
#include <iostream>
#include <dlfcn.h>

int main(int argc, char **argv)
{
    void* motion_library;
    dlerror(); // purge error messages
    motion_library = dlopen("./libmotion.so", RTLD_LAZY);
    if (motion_library == NULL) {
        std::cerr << "could not load libmotion.so: " << dlerror() << std::endl;
    } else {
        dlerror(); // purge error messages
        void* initializer = dlsym(motion_library, "main_loop");
        if(initializer == NULL) {
            std::cerr << "could not find main_loop" << dlerror() << std::endl;
        } else {
           // cast initializer to its proper type and use
           void (*main_loop)(unsigned int) = reinterpret_cast<void (*)(unsigned int)>(initializer);
           main_loop(1000);
        }
        dlclose(motion_library);
    }
    return 0;
}
